BASE:I("Checking statics")


function DestroyStatic()
    local function destroyStaticIfAlive(staticName)
        local static = STATIC:FindByName(staticName, false)
        if static and static:IsAlive() then
            static:Destroy(true)
            
        end
    end




    if zones.secrettechfacility and zones.secrettechfacility.active == false then
        for _, staticName in ipairs({"Static M92 Building05 PBR-1", "Static M92 Sandbag 17-3", 
		"Static TowerCrane-1", "Static M92 Sandbag 13-11", "Static M92 Tent 01-1", "Static M92 Sandbag 06-6", "Static M92 Sandbag 06-6", "Static M92 HESCO generator-25", 
		"Static M92 Sandbag 03-6", "Static M92 Sandbag 03-5", "Static M92 Tent 04-6", "Static M92 Sandbag 06-2",
		"Static M92 Tent 04-6", "Static M92 Sandbag 03-8", "Static M92 Sandbag 03-7", "Static M92 Shelter 01-2", "Static M92 Sandbag 06-5"}) do
            destroyStaticIfAlive(staticName)
        end
    end

    if zones.fueldepo and zones.fueldepo.active == false then
        for _, staticName in ipairs({"Static Pump station-1", "Static Pump station-2", "Static Nodding Donkey Pump-2", "Static Nodding Donkey Pump-3", 
		"Static Nodding Donkey Pump-7", "Static Pump station-4", "Static Nodding Donkey Pump-6", "Static Nodding Donkey Pump-5",
		"Static Nodding Donkey Pump-1", "Static Nodding Donkey Pump-4", "Static Nodding Donkey Pump-8", "Static Nodding Donkey Pump-10", 
		"Static Nodding Donkey Pump-9", "Static Pump station-3", "Fueldepo1", "Fueldepo2", "Fueldepo3", "Fueldepo4", "Fueldepo5", "Fueldepo6", 
		"Static M92 Sandbag 02-25", "Static M92 Sandbag 02-26", "Static M92 Sandbag 02-24", "Static M92 Sandbag 02-23"}) do
            destroyStaticIfAlive(staticName)
        end
    end

	if zones.chemsite and zones.chemsite.active == false then
        for _, staticName in ipairs({"Static M92 Sandbag 17-4", 
		"Static M92 Building05 PBR-2", "Static M92 Sandbag 03-11", "Static M92 Tent 04-7", "Static M92 Shelter 01-3", 
		"Static M92 Sandbag 03-12", "Static M92 Sandbag 03-10", "Static M92 Sandbag 03-9"}) do
            destroyStaticIfAlive(staticName)
        end
    end
	
    if zones.miningfacility and zones.miningfacility.active == false then
        for _, staticName in ipairs({"Static M92 Cargo 04-1", "Static M92 HESCO generator-29", "Static M92 HESCO generator-28", 
		"Static M92 Cargo 04-2", "Static M92 HESCO generator-27", "Static M92 Cargo 04-3", "Static M92 HESCO generator-26", 
		"Static M92 Cargo 04-4", "Static M92 Sandbag 03-13", "Static M92 Sandbag 03-14", "Static Road outpost-3", "Static M92 Sandbag 06-8", 
		"Static M92 HESCO generator-30", "Static M92 HESCO generator-31", "Static M92 Tent 04-8", "Static M92 Tent 04-9", 
		"Static M92 Tent 04-10"}) do
            destroyStaticIfAlive(staticName)
        end
    end

	if zones.insurgentcamp and zones.insurgentcamp.active == false then
        for _, staticName in ipairs({"Static M92 Camouflage 04-18", "Static FARP Tent-81", "Static FARP Tent-82", 
		"Static M92 Building08 PBR-4", "Static Road outpost-1", "Static M92 Camouflage 06-2"}) do
            destroyStaticIfAlive(staticName)
        end
    end

	if zones.ammonitiondepo and zones.ammonitiondepo.active == false then
        for _, staticName in ipairs({"Ammodepo2", "Static M92 Camouflage 07-13", "Static M92 Camouflage 07-12", "Ammodepo4", 
		"Static M92 Shelter 01-4", "Ammodepo3", "Ammodepo1"}) do
            destroyStaticIfAlive(staticName)
        end
    end

	if zones.tankfactory and zones.tankfactory.active == false then
        for _, staticName in ipairs({"Static M92 Sandbag 04-3", "Static M92 Sandbag 04-4", "Static Road outpost-2", 
		"TankFactory3", "TankFactory1", "Static M92 Building08 PBR-5", "Static M92 Building08 PBR-6", 
		"Static M92 Building08 PBR-7", "TankFactory4", "TankFactory2", "", "", ""}) do
            destroyStaticIfAlive(staticName)
        end
    end

end



DestroyStatic()

BASE:I("Checking statics completed")

